package com.example.longpollingbug;

import java.util.concurrent.Executors;

import javax.servlet.annotation.WebServlet;

import com.vaadin.annotations.Push;
import com.vaadin.annotations.Theme;
import com.vaadin.annotations.VaadinServletConfiguration;
import com.vaadin.server.VaadinRequest;
import com.vaadin.server.VaadinServlet;
import com.vaadin.shared.ui.ui.Transport;
import com.vaadin.ui.Label;
import com.vaadin.ui.UI;
import com.vaadin.ui.VerticalLayout;

@SuppressWarnings("serial")
@Theme("longpollingbug")
@Push(transport = Transport.LONG_POLLING)
public class LongpollingbugUI extends UI {

	@WebServlet(value = "/*", asyncSupported = true)
	@VaadinServletConfiguration(productionMode = false, ui = LongpollingbugUI.class)
	public static class Servlet extends VaadinServlet {
	}

	@Override
	protected void init(VaadinRequest request) {
	    final VerticalLayout layout = new VerticalLayout();
        layout.setMargin(true);
        setContent(layout);

        final Label label = new Label("Starting...");
        layout.addComponent(label);
        Executors.newCachedThreadPool().submit(new Runnable() {
            
            @Override
            public void run() {
                try {
                    Thread.sleep(3000);
                } catch (Exception e) {}
                UI.getCurrent().access(new Runnable() {
                    
                    @Override
                    public void run() {
                        label.setValue("Async update!");                        
                    }
                });
            }
            
        });
	}

}